import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import TeknisaComponents from '@zeedhi/teknisa-components-vuetify';
import TekLibComponents from '@zeedhi/tek-lib';
import { ZdAvatar } from '@zeedhi/zd-avatar';
import { Icons } from '@zeedhi/common';
import { ZdRating } from '@zeedhi/zd-rating';
import { ZdCalendar } from '@zeedhi/zd-calendar';
import {
  ZdECharts,
  echartsCore,
  echartsCharts,
  echartsComponents,
} from '@zeedhi/zd-echarts';
import {
  Messages,
  KeyMap,
  Loader,
} from '@zeedhi/core';
import router from '../router';
import controllers from '../controllers';
import config from '../config/config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';

Icons.addIcons({
  iconName: 'mdi-icon-id',
});

Vue.use(Zeedhi, {
  controllers,
  router,
  config,
});

Vue.use(ZeedhiComponents);
Vue.use(TeknisaComponents);
Vue.use(TekLibComponents);

Vue.component('ZdAvatar', ZdAvatar);
Vue.component('ZdRating', ZdRating);
Vue.component('ZdCalendar', ZdCalendar);
Vue.component('ZdECharts', ZdECharts);

echartsCore.use([
  echartsCharts.PieChart,
  echartsCharts.BarChart,
  echartsCharts.LineChart,
  echartsComponents.GridComponent,
]);

vuetify.framework.icons.values = Icons.getIcons() as any;

Messages.add({
  'pt-BR': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-CL': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-CO': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-ES': {
    translation: {
      KEY: 'valor',
    },
  },
  'en-US': {
    translation: {
      KEY: 'value',
    },
  },
});

const appController = Loader.getInstance('AppController');

KeyMap.bind({
  esc: {
    event: () => { appController.escAction(); },
    stop: true,
  },
});
